/****************************************************************************/
/*                                                                          */
/*  Ui_DialogSettings.c :  Fentre de paramtrage.                          */
/*                                                                          */
/****************************************************************************/
/*  Auteur : Franois GAUTHIER   *   Cooperteam   *   Date : Septembre 2010 */
/****************************************************************************/

#include <windows.h>
#include <commctrl.h>

#include <stdio.h>
#include <stdlib.h>

#include "Dc_Shared.h"
#include "Dc_Memory.h"
#include "Dc_Window.h"
#include "Dc_File.h"
#include "resource.h"
#include "Ui_DialogSelect.h"
#include "Ui_DialogMain.h"
#include "Ui_DialogSettings.h"

BOOL CALLBACK SettingsDialogProc(HWND,UINT,WPARAM,LPARAM);

/*****************************************************************************/
/*  Show_Picture_Settings_Window() :  Cration de la fentre de paramtrage. */
/*****************************************************************************/
int ShowPictureSettingsWindow(HWND Param1)
{
  HINSTANCE hInstance;
  HWND hDialog;
  HWND hSettingsWin;
  int value;
  
  my_Windows(WINDOWS_GET_HDIALOGMAIN,&hDialog,NULL);
  my_Windows(WINDOWS_GET_INSTANCE,&hInstance,NULL);
  
  /* Creation de la fentre et rcupration du handle de celle-ci */
  hSettingsWin = CreateDialog(hInstance,MAKEINTRESOURCE(IDD_DIALOG3),hDialog,(DLGPROC)SettingsDialogProc);
  if(hSettingsWin == NULL)
    return(-1);
 
  /* Affichage de la fentre */
  ShowWindow(hSettingsWin,SW_SHOW);

  /* Positionne la fentre */
  value = SetWindowPos(hSettingsWin,HWND_TOP,1040,270,-1,-1,SWP_NOSIZE);
  if(value == 0)
    return(-1);

  return(0);
}


/********************************************************************************/
/*  SettingsDialogProc() :  Fonction de traitement des messages de la fentre.  */
/********************************************************************************/
BOOL CALLBACK SettingsDialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
  char buffer[1024] = "";
  int select_made, error, buffer_length, i, delay_ms, nb_removed, nb_total;
  static int started, delay;
  LRESULT get_state;
  OPENFILENAME of_name;
  HWND hItem;
  HWND hDialogMain;
  struct window_settings *current_settings;
  struct window_title *active_window;

  /* Init */
  my_Memory(MEMORY_GET_WINDOWSETTINGS,&current_settings,NULL);
  my_Memory(MEMORY_GET_ACTIVEWINDOW,&active_window,NULL);
  my_Windows(WINDOWS_SET_HDIALOGSETTINGS,&hDlg,NULL);

  switch(message)
    { 
      case WM_INITDIALOG:
        /** Renseigne les informations de la fentre active **/
        if(active_window != NULL)
          {
            /* Titre de la fentre */
            SetWindowText(GetDlgItem(hDlg,IDC_TARGET_WINDOW),active_window->title);

            /* Taille de la fentre */
            sprintf(buffer,"%dx%d",active_window->delta_rc_window_width,active_window->delta_rc_window_height);
            SetWindowText(GetDlgItem(hDlg,IDC_STATIC_WINDOWSIZEVALUE),buffer);

            /* Taille de la zone client */
            sprintf(buffer,"(%dx%d)",active_window->delta_rc_client_width,active_window->delta_rc_client_height);
            SetWindowText(GetDlgItem(hDlg,IDC_STATIC_CLIENTSIZEVALUE),buffer);
          }

        /** Places les valeurs de Paramtres prcdemment enregistrs **/
        /* Si Top-Most a t coch */
        if(current_settings->top_most == 1)
          SendMessage(GetDlgItem(hDlg,IDC_CHECK_SETTOPMOST),BM_SETCHECK,BST_CHECKED,0);

        /* Si Get Client Area Only a t coch : On active les lments */
        if(current_settings->client_area == 1)
          {
            SendMessage(GetDlgItem(hDlg,IDC_CHECK_CLIENTAREA),BM_SETCHECK,BST_CHECKED,0);
            EnableWindow(GetDlgItem(hDlg,IDC_STATIC_MARGIN),TRUE);
            EnableWindow(GetDlgItem(hDlg,IDC_EDIT_BOTTOM),TRUE);
            EnableWindow(GetDlgItem(hDlg,IDC_STATIC_BOTTOM),TRUE);
            EnableWindow(GetDlgItem(hDlg,IDC_EDIT_LEFT),TRUE);
            EnableWindow(GetDlgItem(hDlg,IDC_STATIC_LEFT),TRUE);
            EnableWindow(GetDlgItem(hDlg,IDC_EDIT_RIGHT),TRUE);
            EnableWindow(GetDlgItem(hDlg,IDC_STATIC_RIGHT),TRUE);
            EnableWindow(GetDlgItem(hDlg,IDC_EDIT_TOP),TRUE);
            EnableWindow(GetDlgItem(hDlg,IDC_STATIC_TOP),TRUE);
          }

        /* Replace les valeur des marges */
        SetWindowText(GetDlgItem(hDlg,IDC_EDIT_BOTTOM),current_settings->bottom);
        SetWindowText(GetDlgItem(hDlg,IDC_EDIT_LEFT),current_settings->left);
        SetWindowText(GetDlgItem(hDlg,IDC_EDIT_RIGHT),current_settings->right);
        SetWindowText(GetDlgItem(hDlg,IDC_EDIT_TOP),current_settings->top);

        /* Si Keep Row a t coch : On active les lments */
        SetWindowText(GetDlgItem(hDlg,IDC_EDIT_ROW),current_settings->row);
        if(current_settings->keep_row == 1)
          {
            SendMessage(GetDlgItem(hDlg,IDC_CHECK_KEEPROW),BM_SETCHECK,BST_CHECKED,0);
            EnableWindow(GetDlgItem(hDlg,IDC_EDIT_ROW),TRUE);
          }
        /* Si Keep Column a t coch : On active les lments */
        SetWindowText(GetDlgItem(hDlg,IDC_EDIT_COLUMN),current_settings->column);
        if(current_settings->keep_column == 1)
          {
            SendMessage(GetDlgItem(hDlg,IDC_CHECK_KEEPCOLUMN),BM_SETCHECK,BST_CHECKED,0);
            EnableWindow(GetDlgItem(hDlg,IDC_EDIT_COLUMN),TRUE);
          }

        /* Use GIF format a t coch */
        if(current_settings->use_gif == 1)
          SendMessage(GetDlgItem(hDlg,IDC_CHECK_USEGIF),BM_SETCHECK,BST_CHECKED,0);

        /** Chemin des fichiers image **/
        SetWindowText(GetDlgItem(hDlg,IDC_EDIT_FILECOUNTER),current_settings->buffer_nb_last_file);
        SetWindowText(GetDlgItem(hDlg,IDC_EDIT_FOLDER),current_settings->folder_path);
        SetWindowText(GetDlgItem(hDlg,IDC_EDIT_FILE),current_settings->file_name);

        /* Append Time/Date a t coch */
        if(current_settings->append_timedate == 1)
          SendMessage(GetDlgItem(hDlg,IDC_CHECK_APPEND_DATETIME),BM_SETCHECK,BST_CHECKED,0);

        /* Si Set Auto a t coch */
        if(current_settings->set_auto == 1)
          {
            hItem = GetDlgItem(hDlg,IDC_CHECK_AUTO_CAPTURE);
            SendMessage(hItem,BM_SETCHECK,BST_CHECKED,0);
            EnableWindow(hItem,TRUE);
            EnableWindow(GetDlgItem(hDlg,IDC_EDIT_DELAY),TRUE);
            EnableWindow(GetDlgItem(hDlg,IDC_STATIC_DELAYS),TRUE);
          }
        /* Si le champs est renseign, il est en millisecondes. On affiche en image/seconde */
        sprintf(buffer,"%d",delay);
        SetWindowText(GetDlgItem(hDlg,IDC_EDIT_DELAY),buffer);

        /** Zone capture de la fentre **/
        UpdatePictureSize(hDlg,active_window,current_settings);

        /* Grise le bouton Settings */
        my_Windows(WINDOWS_GET_HDIALOGMAIN,&hDialogMain,NULL);
        my_Button(BUTTON_SETTINGS_OFF,hDialogMain);

        /* Grise le bouton Start */
        my_Button(BUTTON_GETPICTURE_OFF,hDialogMain);

        /* Grise Set-TopMost s'il n'y a pas de fentre  laquelle appliquer ce critre */
        if(active_window == NULL)
          my_Button(CHECKBOX_TOPMOST_OFF,hDlg);
        break;
        
      case WM_COMMAND:
        if(LOWORD(wParam) == IDC_BUTTON_PATHDLG)
          {
            /* init */
            memset(&of_name,0,sizeof(OPENFILENAME));
            of_name.lStructSize = sizeof(OPENFILENAME);
            of_name.hwndOwner = hDlg;
            of_name.hInstance = NULL; 
            of_name.lpstrFilter = "Bitmap (.bmp)\0*.bmp\0\0";
            of_name.lpstrCustomFilter = NULL;
            of_name.nFilterIndex = 1;
            of_name.lpstrFile = current_settings->file_name;
            of_name.nMaxFile = BUFFER_SIZE;
            of_name.lpstrFileTitle = NULL;
            of_name.lpstrInitialDir = current_settings->folder_path;
            of_name.lpstrTitle = "Select Target Folder";
            of_name.nFileOffset = 0;
            of_name.lpstrDefExt = ".bmp";
            of_name.pvReserved = NULL;
            of_name.dwReserved = 0;
            of_name.FlagsEx = OFN_EX_NOPLACESBAR;
            error = GetSaveFileName(&of_name);
            /* En cas de succs, error est diffrent de 0. On met alors a jour l'affichage du chemin sur la fentre principale */
            if(error)
              {
                sprintf(buffer,"%s%s",current_settings->file_name,current_settings->buffer_nb_last_file);
                buffer_length = strlen(buffer);
                for(i=buffer_length; i>0; i--)
                  if(buffer[i] == '\\')
                    {
                      
                      buffer[i] = '\0';
                      break;
                    }
                SetWindowText(GetDlgItem(hDlg,IDC_EDIT_FOLDER),buffer);

                sprintf(buffer,"%s",current_settings->file_name);
                buffer_length = strlen(buffer);
                for(i=buffer_length; i>0; i--)
                  {
                    if(buffer[i] == '.')
                      buffer[i] = '\0';
                    if(buffer[i] == '\\')
                      break;
                  }
                SetWindowText(GetDlgItem(hDlg,IDC_EDIT_FILE),&buffer[i+1]);
              }
         }
       else if(LOWORD(wParam) == IDC_CHECK_CLIENTAREA)
         { 
           /** Les options de marges deviennent accessibles **/
           if(current_settings->client_area != 1)
             {
               current_settings->client_area = 1;
               EnableWindow(GetDlgItem(hDlg,IDC_EDIT_TOP),TRUE);
               EnableWindow(GetDlgItem(hDlg,IDC_EDIT_BOTTOM),TRUE);
               EnableWindow(GetDlgItem(hDlg,IDC_EDIT_RIGHT),TRUE);
               EnableWindow(GetDlgItem(hDlg,IDC_EDIT_LEFT),TRUE);
               EnableWindow(GetDlgItem(hDlg,IDC_STATIC_TOP),TRUE);
               EnableWindow(GetDlgItem(hDlg,IDC_STATIC_BOTTOM),TRUE);
               EnableWindow(GetDlgItem(hDlg,IDC_STATIC_RIGHT),TRUE);
               EnableWindow(GetDlgItem(hDlg,IDC_STATIC_LEFT),TRUE);
               EnableWindow(GetDlgItem(hDlg,IDC_STATIC_MARGIN),TRUE);
 
               /* 1re initialisation  0 */
               if(strlen(current_settings->top) == 0 || strlen(current_settings->bottom) == 0 || strlen(current_settings->left) == 0 || strlen(current_settings->right) == 0)
                 {
                   SetWindowText(GetDlgItem(hDlg,IDC_EDIT_TOP),"0");
                   SetWindowText(GetDlgItem(hDlg,IDC_EDIT_BOTTOM),"0");
                   SetWindowText(GetDlgItem(hDlg,IDC_EDIT_RIGHT),"0");
                   SetWindowText(GetDlgItem(hDlg,IDC_EDIT_LEFT),"0");
                   strcpy(current_settings->top,"0");
                   strcpy(current_settings->bottom,"0");
                   strcpy(current_settings->left,"0");
                   strcpy(current_settings->right,"0");
                 }
               else
                 {
                   /* On remet les valeurs dj saisies */
                   SetWindowText(GetDlgItem(hDlg,IDC_EDIT_TOP),current_settings->top);
                   SetWindowText(GetDlgItem(hDlg,IDC_EDIT_BOTTOM),current_settings->bottom);
                   SetWindowText(GetDlgItem(hDlg,IDC_EDIT_LEFT),current_settings->left);
                   SetWindowText(GetDlgItem(hDlg,IDC_EDIT_RIGHT),current_settings->right);
                 }
             }
           else
             {
               /* Les options de marges deviennent inaccessibles */
               current_settings->client_area = 0;
               EnableWindow(GetDlgItem(hDlg,IDC_EDIT_TOP),FALSE);
               EnableWindow(GetDlgItem(hDlg,IDC_EDIT_BOTTOM),FALSE);
               EnableWindow(GetDlgItem(hDlg,IDC_EDIT_RIGHT),FALSE);
               EnableWindow(GetDlgItem(hDlg,IDC_EDIT_LEFT),FALSE);
               EnableWindow(GetDlgItem(hDlg,IDC_STATIC_TOP),FALSE);
               EnableWindow(GetDlgItem(hDlg,IDC_STATIC_BOTTOM),FALSE);
               EnableWindow(GetDlgItem(hDlg,IDC_STATIC_RIGHT),FALSE);
               EnableWindow(GetDlgItem(hDlg,IDC_STATIC_LEFT),FALSE);
               EnableWindow(GetDlgItem(hDlg,IDC_STATIC_MARGIN),FALSE);
             }

            /** On met  jour la dimension de la zone capture **/
            UpdatePictureSize(hDlg,active_window,current_settings);
          }
        else if(LOWORD(wParam) == IDC_EDIT_TOP || LOWORD(wParam) == IDC_EDIT_BOTTOM || LOWORD(wParam) == IDC_EDIT_LEFT || LOWORD(wParam) == IDC_EDIT_RIGHT)
          {
            /** On a chang les valeurs de marges : on stoque les valeurs **/
            GetWindowText(GetDlgItem(hDlg,IDC_EDIT_BOTTOM),buffer,4);
            if(strlen(buffer) > 0)
              sprintf(current_settings->bottom,"%s",buffer);
            GetWindowText(GetDlgItem(hDlg,IDC_EDIT_TOP),buffer,4);
            if(strlen(buffer) > 0)
              sprintf(current_settings->top,"%s",buffer);
            GetWindowText(GetDlgItem(hDlg,IDC_EDIT_LEFT),buffer,4);
            if(strlen(buffer) > 0)
              sprintf(current_settings->left,"%s",buffer);
            GetWindowText(GetDlgItem(hDlg,IDC_EDIT_RIGHT),buffer,4);
            if(strlen(buffer) > 0)
              sprintf(current_settings->right,"%s",buffer);

            /** On met  jour la dimension de la zone capture **/
            UpdatePictureSize(hDlg,active_window,current_settings);
          }
        else if(LOWORD(wParam) == IDC_CHECK_KEEPROW)
          {
            /* On ne prend que 1 ligne sur Y */
            if(current_settings->keep_row != 1)
              {
                current_settings->keep_row = 1;
                EnableWindow(GetDlgItem(hDlg,IDC_EDIT_ROW),TRUE);
              }
            else
              {
                current_settings->keep_row = 0;
                EnableWindow(GetDlgItem(hDlg,IDC_EDIT_ROW),FALSE);
              }

            /** On met  jour la dimension de la zone capture **/
            UpdatePictureSize(hDlg,active_window,current_settings);
          }
        else if(LOWORD(wParam) == IDC_CHECK_KEEPCOLUMN)
          {
            /* On ne prend que 1 colonne sur X */
            if(current_settings->keep_column != 1)
              {
                current_settings->keep_column = 1;
                EnableWindow(GetDlgItem(hDlg,IDC_EDIT_COLUMN),TRUE);
              }
            else
              {
                current_settings->keep_column = 0;
                EnableWindow(GetDlgItem(hDlg,IDC_EDIT_COLUMN),FALSE);
              }

            /** On met  jour la dimension de la zone capture **/
            UpdatePictureSize(hDlg,active_window,current_settings);
          }
        else if(LOWORD(wParam) == IDC_EDIT_ROW || LOWORD(wParam) == IDC_EDIT_COLUMN)
          {
            /** On a chang les valeurs de slection lignes/colonnes : on stoque les valeurs **/
            GetWindowText(GetDlgItem(hDlg,IDC_EDIT_ROW),buffer,4);
            if(strlen(buffer) > 0)
              sprintf(current_settings->row,"%s",buffer);
            GetWindowText(GetDlgItem(hDlg,IDC_EDIT_COLUMN),buffer,4);
            if(strlen(buffer) > 0)
              sprintf(current_settings->column,"%s",buffer);

            /** On met  jour la dimension de la zone capture **/
            UpdatePictureSize(hDlg,active_window,current_settings);
          }
        else if(LOWORD(wParam) == IDC_CHECK_SETTOPMOST)
          {
            /* Si l'utilisateur a coch/dcoch l'option Top-Most */
            if(current_settings->top_most != 1 && active_window != NULL)
              {
                SetWindowPos(active_window->hWnd,HWND_TOPMOST,-1,-1,-1,-1,SWP_NOMOVE|SWP_NOSIZE);
                current_settings->top_most = 1;
                /* Retabli la fentre si elle est iconifie */
                OpenIcon(active_window->hWnd);
              }
            else if(current_settings->top_most == 1 && active_window != NULL)
              {
                SetWindowPos(active_window->hWnd,HWND_NOTOPMOST,-1,-1,-1,-1,SWP_NOMOVE|SWP_NOSIZE);
                current_settings->top_most = 0;
                /* Retabli la fentre si elle est iconifie */
                OpenIcon(active_window->hWnd);
              }
          }
        else if(LOWORD(wParam) == ID_BTN_SELECT_WINDOW)
          {
            my_Memory(MEMORY_FREE_WINDOWTITLE,NULL,NULL);

            /* On grise le bouton select */
            my_Button(BUTTON_SELECTWINDOW_OFF,hDlg);

            /* Enumration des fentres */
            EnumWindows(EnumWindowsProc,0);
            
            /* Trie par ordre alphabtique de la liste chaine */
            my_Memory(MEMORY_SORT_WINDOWTITLE,NULL,NULL);
          
            /* Affichage de la fentre de slection*/
            select_made = ShowPictureSelectionWindow(hDlg);

            /* On annule le Top-Most */
            if(active_window != NULL)
              SetWindowPos(active_window->hWnd,HWND_NOTOPMOST,-1,-1,-1,-1,SWP_NOMOVE|SWP_NOSIZE);

            /* La fentre active est annule */
            my_Memory(MEMORY_CLEAR_ACTIVEWINDOW,NULL,NULL);

            /* On dcoche la checkbox Set-TopMost et on la grise */
            SendMessage(GetDlgItem(hDlg,IDC_CHECK_SETTOPMOST),BM_SETCHECK,BST_UNCHECKED,0);
            my_Button(CHECKBOX_TOPMOST_OFF,hDlg);   
          }
        else if(LOWORD(wParam) == ID_BTN_CLEAN_FOLDER)
          {
            /** Supprime les images conscutives identiques **/
            nb_removed = RemoveDuplicatedPictures(current_settings->folder_path,current_settings->file_name,&nb_total);

            /* On indique combien de fichiers ont t supprims */
            sprintf(buffer,"%d/%d Picture%s were deleted !",nb_removed,nb_total,(nb_removed>1)?"s":"");
            MessageBox(hDlg,buffer,"Remove Duplicated Pictures",MB_APPLMODAL);
          }
        else if(LOWORD(wParam) == IDC_CHECK_AUTO_CAPTURE)
          {
            /* Change le "Caption" du bouton Start/Stop */
            SetWindowText(GetDlgItem(hDlg,ID_BTN_GETPICTURE),"Start");

            /* Active ou dsactive les champs lis  la check box "Auto-Capture" */
            if(current_settings->set_auto != 1)
              {
                current_settings->set_auto = 1;
                EnableWindow(GetDlgItem(hDlg,IDC_EDIT_DELAY),TRUE);
                EnableWindow(GetDlgItem(hDlg,IDC_STATIC_DELAYS),TRUE);
                EnableWindow(GetDlgItem(hDlg,IDC_STATIC_ELAPSEDCAPTION),TRUE);
                EnableWindow(GetDlgItem(hDlg,IDC_STATIC_TIME),TRUE);
                EnableWindow(GetDlgItem(hDlg,IDC_BUTTON_RESET),TRUE);
              }
            else
              {
                current_settings->set_auto = 0;
                EnableWindow(GetDlgItem(hDlg,IDC_EDIT_DELAY),FALSE);
                EnableWindow(GetDlgItem(hDlg,IDC_STATIC_DELAYS),FALSE);
                EnableWindow(GetDlgItem(hDlg,IDC_STATIC_ELAPSEDCAPTION),FALSE);
                EnableWindow(GetDlgItem(hDlg,IDC_STATIC_TIME),FALSE);
                EnableWindow(GetDlgItem(hDlg,IDC_BUTTON_RESET),FALSE);
              }
          }
        else if(LOWORD(wParam) == ID_OK_SETTINGS)
          {
            /** On va vrifier la dimension de l'image (taille des marges) **/
            if(active_window != NULL)
              if(current_settings->client_area == 1)
                {
                  if((atoi(current_settings->left) + atoi(current_settings->right) >= active_window->delta_rc_client_width) || 
                     (atoi(current_settings->top) + atoi(current_settings->bottom) >= active_window->delta_rc_client_height))
                    {
                      MessageBox(hDlg,"Margins can't be larger than Client Area size !","Margin Size Error",MB_APPLMODAL);
                      return(FALSE);
                    }
                }

            /** Remplissage de la structure settings **/
            /* Set-TopMost est-il coch? */
            get_state = SendMessage(GetDlgItem(hDlg,IDC_CHECK_SETTOPMOST),BM_GETSTATE,0,0);
            current_settings->top_most = (get_state == BST_CHECKED) ? 1 : 0;

            /* Get Client Area Only est-il coch? */
            get_state = SendMessage(GetDlgItem(hDlg,IDC_CHECK_CLIENTAREA),BM_GETSTATE,0,0);
            current_settings->client_area = (get_state == BST_CHECKED) ? 1 : 0;

            /* Get Row est-il coch? */
            get_state = SendMessage(GetDlgItem(hDlg,IDC_CHECK_KEEPROW),BM_GETSTATE,0,0);
            current_settings->keep_row = (get_state == BST_CHECKED) ? 1 : 0;

            /* Get Column est-il coch? */
            get_state = SendMessage(GetDlgItem(hDlg,IDC_CHECK_KEEPCOLUMN),BM_GETSTATE,0,0);
            current_settings->keep_column = (get_state == BST_CHECKED) ? 1 : 0;

            /* Use GIF format est-il coch? */
            get_state = SendMessage(GetDlgItem(hDlg,IDC_CHECK_USEGIF),BM_GETSTATE,0,0);
            current_settings->use_gif = (get_state == BST_CHECKED) ? 1 : 0;

            /* Nom de fichier et chemin */
            GetWindowText(GetDlgItem(hDlg,IDC_EDIT_FILE),current_settings->file_name,BUFFER_SIZE);
            GetWindowText(GetDlgItem(hDlg,IDC_EDIT_FOLDER),current_settings->folder_path,BUFFER_SIZE);
            GetWindowText(GetDlgItem(hDlg,IDC_EDIT_FILECOUNTER),current_settings->buffer_nb_last_file,BUFFER_SIZE);

            /* Append Time/Date est-il coch? */
            get_state = SendMessage(GetDlgItem(hDlg,IDC_CHECK_APPEND_DATETIME),BM_GETSTATE,0,0);
            current_settings->append_timedate = (get_state == BST_CHECKED) ? 1 : 0;

            /* Set-Auto est il coch? Si oui, on stocke aussi le dlai */
            get_state = SendMessage(GetDlgItem(hDlg,IDC_CHECK_AUTO_CAPTURE),BM_GETSTATE,0,0);
            if(get_state == BST_CHECKED)
              {
                GetWindowText(GetDlgItem(hDlg,IDC_EDIT_DELAY),buffer,4);
                delay = atoi(buffer);
                /* Bornes de la saisie utilisateur */
                if(delay < 1)
                  {
                    SetWindowText(GetDlgItem(hDlg,IDC_EDIT_DELAY),"1");
                    delay = 1;
                    return(FALSE);
                  }
                else if(delay > 100)
                  {
                    SetWindowText(GetDlgItem(hDlg,IDC_EDIT_DELAY),"100");
                    delay = 100;
                    return(FALSE);
                  }
                current_settings->set_auto = 1;

                /* Conversion en millisecondes pour le traitement */
                delay_ms = 1000/delay;
                sprintf(current_settings->delay,"%d",delay_ms);
              }
            else
              {
                current_settings->set_auto = 0;
                strcpy(current_settings->delay,"0");
              }

            /* Mise a jour du fichier prfrences */
            UpdateUserPreferences(current_settings);

            /* Recupre le Handle de la fentre principale et active le bouton  */
            my_Windows(WINDOWS_GET_HDIALOGMAIN,&hDialogMain,NULL);
            if(active_window != NULL)
                my_Button(BUTTON_GETPICTURE_ON,hDialogMain);
            else
              my_Button(BUTTON_GETPICTURE_OFF,hDlg);
            my_Button(BUTTON_SETTINGS_ON,hDialogMain);

            /* Fermeture de la fentre Settings */
            EndDialog(hDlg,0);
          }
      break;

      default:
        return(FALSE);
    }

  return(TRUE);
}


/*******************************************************************/
/*  UpdatePictureSize() :  Met  jour la taille de l'image finale. */
/*******************************************************************/
void UpdatePictureSize(HWND hDialog_settings, struct window_title *active_window, struct window_settings *current_settings)
{
  int width, height;
  int column, row, extra;
  char buffer[1024];

  /* Aucune fentre slectionne */
  if(active_window == NULL || current_settings == NULL)
    {
      SetWindowText(GetDlgItem(hDialog_settings,IDC_STATIC_PICTURESIZEVALUE),"");
      return;
    }

  /** Taille de la fentre **/
  if(current_settings->client_area == 1)
    {
      /* La Zone client moins les marges */
      width = active_window->delta_rc_client_width - (atoi(current_settings->left) + atoi(current_settings->right));
      height = active_window->delta_rc_client_height - (atoi(current_settings->top) + atoi(current_settings->bottom));
    }
  else
    {
      /* Fentre entire */
      width = active_window->delta_rc_window_width;
      height = active_window->delta_rc_window_height;
    }

  /** Taille de l'image finale **/
  if(current_settings->keep_column == 1)
    {
      /* 1 colonne sur X */
      column = strlen(current_settings->column) == 0 ? 1 : atoi(current_settings->column);
      if(column <= 0)
        column = 1;
      extra = (column * (width / column)) < width ? 1 : 0;
      width = (width / column) + extra;
    }
  if(current_settings->keep_row == 1)
    {
      /* 1 ligne sur Y */
      row = strlen(current_settings->row) == 0 ? 1 : atoi(current_settings->row);
      if(row <= 0)
        row = 1;
      extra = (row * (height / row)) < height ? 1 : 0;
      height = (height / row) + extra;
    }

  /* Met  jour l'affichage */
  sprintf(buffer,"%dx%d",width,height);
  SetWindowText(GetDlgItem(hDialog_settings,IDC_STATIC_PICTURESIZEVALUE),buffer);
}

/****************************************************************************/